"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2019-2022 Exabel AS. All rights reserved."""
import builtins
import collections.abc
from ..... import exabel
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import sys
if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions
DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class Signal(google.protobuf.message.Message):
    """A signal resource in the Data API. Signals are normally associated with a set of entity types,
    but may apply to any entities.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    ENTITY_TYPE_FIELD_NUMBER: builtins.int
    DISPLAY_NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    DOWNSAMPLING_METHOD_FIELD_NUMBER: builtins.int
    READ_ONLY_FIELD_NUMBER: builtins.int
    ENTITY_TYPES_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Unique resource name of the raw data signal, e.g. `signals/signalIdentifier` or\n    `signals/namespace.signalIdentifier`. The namespace must be empty (being global) or a\n    namespace accessible to the customer.\n    The signal identifier must match the regex `[a-zA-Z]\\w{0,63}`.\n    '
    entity_type: builtins.str
    'No longer in use.'
    display_name: builtins.str
    'Used when showing the signal in the Exabel app. Required when creating a signal.'
    description: builtins.str
    'Used when showing the signal in the Exabel app.'
    downsampling_method: exabel.api.math.aggregation_pb2.Aggregation.ValueType
    'The default downsampling method to use when this signal is re-sampled into larger intervals.\n    When two or more values in an interval needs to be aggregated into a single value, specifies\n    how they are combined.\n    '
    read_only: builtins.bool
    'Global signals and those from data sets that you subscribe to will be read-only.'

    @property
    def entity_types(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """List of entity types that this signal has time series for, e.g.
        `entityTypes/ns.type1`, `entityTypes/ns.type2`.
        """

    def __init__(self, *, name: builtins.str | None=..., entity_type: builtins.str | None=..., display_name: builtins.str | None=..., description: builtins.str | None=..., downsampling_method: exabel.api.math.aggregation_pb2.Aggregation.ValueType | None=..., read_only: builtins.bool | None=..., entity_types: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing_extensions.Literal['description', b'description', 'display_name', b'display_name', 'downsampling_method', b'downsampling_method', 'entity_type', b'entity_type', 'entity_types', b'entity_types', 'name', b'name', 'read_only', b'read_only']) -> None:
        ...
global___Signal = Signal